import numpy as np
from mlp import *

#testing the MSE Gradient Descent
N = 30                                              
d_in = 3                                            
d_h = 3                                             
d_out = 2                                           
w1 = 2 * np.random.rand(d_in, d_h) - 1              
b1 = np.zeros((1, d_h))                             
w2 = 2 * np.random.rand(d_h, d_out) - 1             
b2 = np.zeros((1, d_out))                           

data = np.random.rand(N, d_in)                      
targets = np.random.rand(N, d_out)                  
learning_rate=0.5

(w1n,b1n,w2n,b2n,loss)=learn_once_mse(w1,b1,w2,b2,data,targets,learning_rate) 
assert 0 < loss < 1
assert w1n.shape==w1.shape

#test the one-hot encoding function

assert ((one_hot(np.array([1,2,0])) == [[0, 1, 0],[0, 0, 1],[1, 0, 0]]).all())==True

#testing the Cross Entropy Gradien descent and the training of the model
(data,labels)=read_cifar_batch(r"C:\Intel\Desktop\DeepLearning\image-classification\data\cifar-10-batches-py\data_batch_1") 

N = data.shape[0]                              
d_in = data.shape[1]                           
d_h = 64                                       
d_out = 10                                     
w1 = 2 * np.random.rand(d_in, d_h) - 1         
b1 = np.zeros((1, d_h))                        
w2 = 2 * np.random.rand(d_h, d_out) - 1        
b2 = np.zeros((1, d_out))                      
learning_rate=0.1                              
num_epoch=100                                  

assert 0< learn_once_cross_entropy(w1,b1,w2,b2,data,labels,learning_rate)[4] 
print(train_mlp(w1,b1,w2,b2,data,labels,learning_rate,num_epoch)[4]) 

#test the model testing function

dir_test =r"C:\Intel\Desktop\DeepLearning\image-classification\data\cifar-10-batches-py\test_batch"
(data_test,labels_test)=read_cifar_batch(dir_test)                  
assert 0< test_mlp(w1,b1,w2,b2,data_test,labels_test) < 100         
